/*
 * Created on Nov 1, 2003
 */
package portaview.dnd;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.io.IOException;

import javax.swing.JComponent;

/**
 * Transfer object for the drag and drop the album to the portaview.
 * @author William Lee
 */
public class AlbumTransfer implements Transferable
{
    public static DataFlavor FLAVOUR;
    protected JComponent source;

    static
    {
        try 
        {
            FLAVOUR = new DataFlavor(DataFlavor.javaJVMLocalObjectMimeType);
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }
    
    public AlbumTransfer(JComponent src)
    {
        this.source = src;
    }
    
    /**
     * Returns  the default data flavor (local jvm object).
     * @see java.awt.datatransfer.Transferable#getTransferDataFlavors()
     */
    public DataFlavor[] getTransferDataFlavors()
    {
        return new DataFlavor[] {FLAVOUR};
    }

    /**
     * Returns true if the flavor is the jvm local MIME type.
     * @see java.awt.datatransfer.Transferable#isDataFlavorSupported(java.awt.datatransfer.DataFlavor)
     */
    public boolean isDataFlavorSupported(DataFlavor flavor)
    {
        return FLAVOUR.equals(flavor);
    }

    /**
     * Returns the transfer data.
     * @see java.awt.datatransfer.Transferable#getTransferData(java.awt.datatransfer.DataFlavor)
     */
    public Object getTransferData(DataFlavor flavor)
        throws UnsupportedFlavorException, IOException
    {
        if (!isDataFlavorSupported(flavor))
            throw new UnsupportedFlavorException(flavor);
        return this;
    }

    /**
     * @return the source for this drag and drop event.
     */
    public JComponent getSource()
    {
        return source;
    }

    /**
     * Sets the source component for this event.
     * @param component the source for the drag and drop.
     */
    public void setSource(JComponent component)
    {
        source = component;
    }

}
