/*
 * Created on Nov 1, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package portaview.dnd;

import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.util.List;

import javax.swing.JComponent;
import javax.swing.TransferHandler;

import portaview.model.SlideSettings;
import portaview.view.AlbumIconView;
import portaview.view.PortaViewView;

/**
 * The transfer handler of for the DnD from the album to the portaview.
 * @author William Lee
 */
public class AlbumTransferHandler extends TransferHandler
{
    /**
     * From the transferable object, import the data to the PortaView icons.
     * This actually changes the model for the PortaView that the user tries
     * to drop to.
     */
    public boolean importData(JComponent c, Transferable t)
    {
        if (!(c instanceof PortaViewView))
            return false;
        PortaViewView pvv = (PortaViewView) c;
        try
        {
            // check the source object
            Object obj = t.getTransferData(AlbumTransfer.FLAVOUR);
            if (!(obj instanceof AlbumTransfer))
                return false;
            AlbumTransfer at = (AlbumTransfer) obj;
            // block dnd to self
            if (c.equals(at.getSource()))
                return false;
            AlbumIconView aiv = (AlbumIconView) at.getSource();
            SlideSettings ss = pvv.getPortaViewModel().getSlideSettings();
            ss.setIndex(0);
            List photos = aiv.getAlbumModel().getPhotos();
            int total = 0;
            if (photos == null)
                total = 0;
            else
                total = photos.size();

            ss.setTotal(total);
            ss.setSlide(aiv.getAlbumModel().getName());
            // notify everything about the change.
            pvv.getPortaViewModel().setSlideSettings(ss);
            return true;
        }
        catch (Exception e)
        {
            e.printStackTrace();
            return false;
        }
    }

    /**
     * Returns true if this handler can handle this event.
     */
    public boolean canImport(JComponent c, DataFlavor[] transferFlavors)
    {
        if (!(c instanceof AlbumIconView))
            return false;
        for (int i = 0; i < transferFlavors.length; i++)
        {
            if (transferFlavors[i].equals(AlbumTransfer.FLAVOUR))
                return true;
        }
        return false;
    }
    
    /**
     * Returns the source actions.
     */
    public int getSourceActions(JComponent c)
    {
        if (!(c instanceof AlbumIconView)) return NONE;
        return COPY_OR_MOVE;
    }
    
    protected Transferable createTransferable(JComponent c)
    {
        if (!(c instanceof AlbumIconView)) return null;
        return new AlbumTransfer(c);
    }
    
    /**
     * Action performed after the drop is completed
     */
    protected void exportDone(JComponent source, Transferable t, int action)
    {
        // we don't really have to do anything here.
        return;
    }
    
}
