/*
 * Created on Oct 27, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package portaview.server;

import java.util.Iterator;

import portaview.Log;
import portaview.Registry;
import portaview.model.PortaViewCollection;
import portaview.model.PortaViewModel;

/**
 * Thread that periodically polls the remote PortaViews and check if you need to update them.
 * @author William Lee
 */
public class PortaViewUpdateRunner extends Thread
{
    private boolean shutdown = false;
    private int POLL_TIME = 5000;

    /**
     * The main loop in the thread.  It currently waits 5 seconds before updating again.
     */
    public void run()
    {
        while (shutdown == false)
        {
            try
            {
                Thread.sleep(POLL_TIME);
                PortaViewCollection pvs = Registry.getServer().getRegisteredPortaViews();
                // compare the pvs with the list we want to get from the master server.
                for (Iterator i = pvs.iterator(); i.hasNext();)
                {
                    PortaViewModel element = (PortaViewModel) i.next();
                    Log.debug(
                        "Updating PV: "
                            + element.getName()
                            + " at "
                            + element.getInetAddress());
                    element.updateRemote();
                }
                //Log.debug("Updating PV.");
                if (shutdown)
                    break;
            }
            catch (InterruptedException e)
            {
                if (shutdown)
                    break;
            }
        }
    }

    /**
     * Shutdown this thread.
     */
    public void shutdown()
    {
        shutdown = true;
        this.interrupt();
    }

}
