/*
 * Created on Sep 28, 2003
 * Copyright (c) 2003.  All rights reserved.
 */
package portaview.util;

import java.io.ByteArrayOutputStream;
import java.io.InputStream;

/**
 * Utility to read in streams.
 * @author <a href="mailto:wwlee1@uiuc.edu">William Lee</a>
 * @version $Id: StreamUtils.java,v 1.2 2003/12/10 06:18:56 wlee Exp $
 */
public class StreamUtils
{
	/**
	 * Reads a stream into a byte array.
	 * @param in The input stream
	 * @return a newly allocated byte array
	 * @throws Exception if there is anything wrong during the read.
	 */
	public static byte[] getBytesFromStream(InputStream in)
		throws Exception
	{
			int chunkSize = 2048;
			byte[] buf = new byte[chunkSize];
			ByteArrayOutputStream byteStream =
				new ByteArrayOutputStream(chunkSize);
			int count;

			while ((count = in.read(buf)) != -1)
				byteStream.write(buf, 0, count);

			return byteStream.toByteArray();
	}
}
