/*
 * Created on Oct 29, 2003
 */
package portaview.view;

import portaview.model.AlbumCollection;
import portaview.model.AlbumModel;

/**
 * Album panel that displays the list of albums.
 *
 * @author William Lee
 */
public class AlbumPanel extends IconPanel
{
    /**
     * Given a list of PortaView models, draw the view.
     * @param portaViews
     */
    public AlbumPanel(AlbumCollection ac)
    {
        super(ac);
    }

    /**
     * Returns the AlbumIconView.
     * @see portaview.view.IconPanel#getViewFromModel(java.lang.Object)
     */
    public Object getViewFromModel(Object model, IconPanel ipanel)
    {
        AlbumIconView aiv = new AlbumIconView((AlbumModel) model, (AlbumPanel)ipanel);
        return aiv;
    }

    /**
     * Clean up the view and model.
     * @see portaview.view.IconPanel#removeView(java.lang.Object)
     */
    public void removeView(Object view)
    {
        AlbumIconView pvv = (AlbumIconView) view;
        pvv.getAlbumModel().deleteObserver(pvv);
    }

}
