/*
 * Created on Sep 30, 2003
 * Copyright (c) 2003.  All rights reserved.
 */
package portaview.view;

import java.awt.Color;

import portaview.AbstractViewer;
import portaview.model.PortaViewModel;

/**
 * Panel to display the pictures.  This represents a View in the MVC model.
 * 
 * @author <a href="mailto:wwlee1@uiuc.edu">William Lee</a>
 * @version $Id: DisplayerView.java,v 1.10 2003/11/16 17:42:27 wlee Exp $
 */
public class DisplayerView extends AbstractDisplayerView
{
    ImageControlBar imgControls = null;
    
	public DisplayerView(PortaViewModel model, AbstractViewer viewer)
	{
	   super(model, viewer);
	   setBackground(Color.black);
	}

    /**
     * Returns the image bar.
     * @see portaview.view.AbstractDisplayerView#getImageControls()
     */
    protected ImageControlBar getImageControls(AbstractViewer viewer)
    {
        imgControls = ImageControlBar.getDisplayBar(viewer);
        return imgControls;
    }

    /**
     * Returns false (does not need label)
     * @see portaview.view.AbstractDisplayerView#needsLabel()
     */
    protected boolean needsLabel()
    {
        return false;
    }

    /**
     * Text for the no picture.
     * @see portaview.view.AbstractDisplayerView#getNoPicText()
     */
    protected String getNoPicText()
    {
        return "No picture selected.  Switch to PortaView Manager to select an Album.";
    }
    
    protected Color getNoPicTextColor()
    {
        return Color.white;
    }

    /**
     * Optimization for refreshing.  Returns true always.g
     * @see portaview.view.AbstractDisplayerView#needRefresh()
     */
    protected boolean needRefresh()
    {
        return true;
    }
}
