/*
 * Created on Oct 26, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package portaview.view;

import portaview.AbstractViewer;
import portaview.Registry;
import portaview.model.PortaViewModel;

/**
 * Implenets the view for the preview panel.
 * @author William Lee
 */
public class PreviewView extends AbstractDisplayerView
{
    ImageControlBar imgControls = null;

    /**
     * Constrctus the preview view with a given model.
     * @param model
     */
    public PreviewView(PortaViewModel model, AbstractViewer viewer)
    {
        super(model, viewer);
    }

    /**
     * Returns the image control bar for the preview view.
     * @see portaview.view.AbstractDisplayerView#getImageControls()
     */
    protected ImageControlBar getImageControls(AbstractViewer viewer)
    {
        imgControls = ImageControlBar.getPreviewBar(viewer);
        return imgControls;
    }

    /**
     * Needs a label, so returns true.
     * @see portaview.view.AbstractDisplayerView#needsLabel()
     */
    protected boolean needsLabel()
    {
        return true;
    }

    /**
     * Text for no album.
     * @see portaview.view.AbstractDisplayerView#getNoPicText()
     */
    protected String getNoPicText()
    {
        return "No album is assigned to this PortaView.";
    }
    
    /**
     * Optimization for refreshing.  Returns true only when the 
     * display is not active.
     * @see portaview.view.AbstractDisplayerView#needRefresh()
     */
    protected boolean needRefresh()
    {
        return (!Registry.getMainApplication().isDisplayActive());
    }

}
