/*
 * Created on Oct 6, 2003
 * Copyright (c) 2003.  All rights reserved.
 */
package test.portaview;

import junit.framework.TestCase;
import portaview.PortaViewMain;
import portaview.model.PortaViewModel;
import portaview.model.SlideSettings;

/**
 * The base test case for all the tests.
 * 
 * @author <a href="mailto:wwlee1@uiuc.edu">William Lee</a>
 * @version $Id: TBase.java,v 1.6 2003/10/29 02:47:19 wlee Exp $
 */
public class TBase extends TestCase
{
    protected static int PORT = 8888;
    protected static String TEST_IMG_BASE = "src/test/test/portaview/images";
    protected static String PNAME = "PortaView 1";
    protected static String[] START_ARGS =
        {
            "-m",
            "-n",
            PNAME,
            "-i",
            "127.0.0.1",
            "-c",
            "127.0.0.1",
            "-a",
            TEST_IMG_BASE };

    protected PortaViewMain pvmain = null;

    public TBase(String name)
    {
        super(name);
    }

    /**
     * Sets up the variables
     */
    protected void setUp()
    {
        try
        {
            pvmain = new PortaViewMain(START_ARGS);
            pvmain.start();
            SlideSettings ss = new SlideSettings();
            ss.setIndex(19999);
            PortaViewModel pvm = pvmain.getThisPortaViewModel();
            pvm.setSlideSettings(ss);
//            Registry.getServer().start();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            fail(e.toString());
        }
    }
    
    /**
     * Deallocates the resources
     */
    protected void tearDown()
    {
        pvmain.shutdown();
        pvmain = null;
    }


    /**
     * Prints out the message when there's a general failure
     * @param e Exception that got thrown as a result of failture.
     */
    protected void generalFail(Exception e)
    {
        fail("General failure " + e.toString());
    }
}
