package test.portaview;

import junit.framework.Test;
import junit.framework.TestSuite;
import portaview.PortaViewMain;
import portaview.Registry;

/*
 * Created on Oct 22, 2003
 * Copyright (c) 2003.  All rights reserved.
 */

/**
 * Testing the command line arguments
 * @author <a href="mailto:wwlee1@uiuc.edu">William Lee</a>
 * @version $Id: TestCmd.java,v 1.2 2003/10/22 21:21:42 wlee Exp $
 */
public class TestCmd extends TBase
{
    protected static String PNAME_2 = "PortaView 2";
    protected static String[] START_ARGS_2 =
        {
            "-n",
            PNAME_2,
            };
    /**
     * @param name
     */
    public TestCmd(String name)
    {
        super(name);
    }

    /**
     * Deallocates the resources
     */
    protected void tearDown()
    {
    }

    protected void setUp()
    {
    }

    /**
     * Tests the command line argument
     *
     */
    public void testPortaViewMainCmd()
    {
        try
        {
            PortaViewMain pvmain = new PortaViewMain(START_ARGS);
            pvmain.start();
            assertTrue(Registry.getServer().getName().equals(PNAME));
            assertTrue(Registry.getServer().getInetAddress().getHostAddress().equals("127.0.0.1"));
            assertTrue(Registry.getServer().getMasterIP().getHostAddress().equals("127.0.0.1"));
            assertTrue(Registry.isMaster());
            pvmain.shutdown();
        }
        catch (Exception e)
        {
            generalFail(e);
        }
    }
    /**
     * Tests the command line argument
     *
     */
    public void testPortaViewMainCmdSlave()
    {
        try
        {
            PortaViewMain pvmain = new PortaViewMain(START_ARGS_2);
            pvmain.start();
            assertTrue(Registry.getServer().getName().equals(PNAME_2));
            assertTrue(Registry.getServer().getInetAddress().getHostAddress().equals("127.0.0.1"));
            assertTrue(Registry.getServer().getMasterIP().getHostAddress().equals("127.0.0.1"));
            assertFalse(Registry.isMaster());
            pvmain.shutdown();
        }
        catch (Exception e)
        {
            generalFail(e);
        }
    }
    
    /** 
     * Constructs a test suite.
     */
    public static Test suite()
    {
        return new TestSuite(TestCmd.class);
    }

}
